import { j as d } from "./chunks/jsx-runtime.mjs";
import { useImperativeHandle as T, forwardRef as j, useState as y, useEffect as F } from "react";
import { u as z, b as K, a as $, C as k } from "./chunks/Editor.mjs";
import { b as m, R as G, g as O, c as V } from "./chunks/index.mjs";
import { f as e, g as Z, p as a } from "./chunks/config.mjs";
const D = (o, n) => {
  const { editorId: r } = o;
  T(
    n,
    () => ({
      rerender() {
        m.emit(r, G);
      }
    }),
    // eslint-disable-next-line react-hooks/exhaustive-deps
    []
  );
}, A = j((o, n) => {
  const {
    modelValue: r = e.modelValue,
    theme: i = e.theme,
    className: u = e.className,
    editorId: l = O(Z + "_"),
    showCodeRowNumber: g = e.showCodeRowNumber,
    previewTheme: c = e.previewTheme,
    noMermaid: h = e.noMermaid,
    noKatex: f = e.noKatex,
    onHtmlChanged: x = e.onHtmlChanged,
    onGetCatalog: I = e.onGetCatalog,
    sanitize: p = e.sanitize,
    mdHeadingId: w = e.mdHeadingId,
    noIconfont: v = e.noIconfont,
    noHighlight: C = e.noHighlight,
    noImgZoomIn: E = e.noImgZoomIn,
    language: H = e.language,
    sanitizeMermaid: b = e.sanitizeMermaid,
    codeFoldable: P = e.codeFoldable,
    autoFoldThreshold: R = e.autoFoldThreshold
  } = o, [t] = y(() => ({
    editorId: l,
    noKatex: f,
    noMermaid: h,
    noIconfont: v,
    noHighlight: C
  }));
  z(t);
  const [M, N, s] = K(o);
  return D(t, n), F(() => () => {
    m.clear(l);
  }, []), /* @__PURE__ */ d.jsx(
    $.Provider,
    {
      value: {
        editorId: t.editorId,
        tabWidth: 2,
        theme: i,
        language: H,
        highlight: M,
        showCodeRowNumber: g,
        usedLanguageText: N,
        previewTheme: c,
        customIcon: o.customIcon || {}
      },
      children: /* @__PURE__ */ d.jsx(
        "div",
        {
          id: t.editorId,
          className: V([
            a,
            u,
            i === "dark" && `${a}-dark`,
            s.fullscreen || s.pageFullscreen ? `${a}-fullscreen` : "",
            `${a}-previewOnly`
          ]),
          style: o.style,
          children: /* @__PURE__ */ d.jsx(
            k,
            {
              modelValue: r,
              setting: s,
              mdHeadingId: w,
              onHtmlChanged: x,
              onGetCatalog: I,
              sanitize: p,
              noMermaid: t.noMermaid,
              noHighlight: t.noHighlight,
              noKatex: t.noKatex,
              formatCopiedText: o.formatCopiedText,
              noImgZoomIn: E,
              previewOnly: !0,
              sanitizeMermaid: b,
              codeFoldable: P,
              autoFoldThreshold: R
            },
            "preview-only"
          )
        }
      )
    }
  );
});
export {
  A as default
};
